# $Id: main.py 65 2005-09-03 22:41:25Z  $

import sys
import pygame
import time
import threading

import playfield
import simulator

WELCOME_SCREEN_IMAGE = pygame.image.load('../media/images/welcome.png')

class Main:
	def __init__(self):
		self.options = {simulator.TARGET_MONEY: 5000, simulator.TARGET_TIME:300}
		
		if (6,0) != pygame.init():
			raise "cannot init pygame"
		pygame.display.set_caption('Capacilator')
		self.window = pygame.display.set_mode((600,400),0)
		self.screen = pygame.display.get_surface()
		
		self.sm = simulator.Simulator(self,self.options)
		self.pf = playfield.Playfield((300,400),self.sm.itemCollectCallback)
		
		self.end_game = False
		self.lastTime = time.time()

		# Draw the main screen
		self.idle_event()
		
		# Overlay the welcome screen on the top of it
		self.showScreenImage(WELCOME_SCREEN_IMAGE)
		
		# Wait for the user to hit Enter
		startGame = False
		while not startGame:
			events = pygame.event.get()
			for event in events:
				if event.type == pygame.QUIT:
					self.end_game = True
					return
				if (event.type == pygame.KEYDOWN) and (event.key == pygame.constants.K_RETURN):
					startGame = True

		
	def showScreenImage(self, image):
		imageRect	= image.get_rect()
		screenRect	= self.screen.get_rect()
		imageRect.move_ip((screenRect.width  - imageRect.width)  / 2,
					   	  (screenRect.height - imageRect.height) / 2)
		self.screen.blit(image, imageRect)
		pygame.display.flip()
		

	def handle_events(self,events):
		for event in events:
			if event.type == pygame.QUIT:
				self.end_game = True
			else:
				if False == self.sm.handleEvent(event):
					if False == self.pf.handleEvent(event):
						pass	

	def idle_event(self):
		currentTime = time.time()
		TimePassed = currentTime-self.lastTime
		self.lastTime = currentTime
	
		self.sm.doFrame(TimePassed)
		self.screen.blit(self.sm.getSurface(),(0,0))
		self.pf.doFrame(TimePassed)
		self.screen.blit(self.pf.getSurface(),(300,0))
	
		pygame.display.flip()
		
	def main_loop(self):
		#try:
			while not self.end_game:
				events = pygame.event.get()
				if [] == events:
					self.idle_event()		
				else:
					self.handle_events(events)
		#except Exception, e:
		#    pygame.quit()
		#    raise e
			pygame.quit()
			raw_input("Press Enter to exit")
		
	def WinLevel(self):
		print "You have won!!"
		self.end_game = True
		
	def LoseLevel(self):
		print "You've lost! buchu buchu!"
		self.end_game = True

m = Main()
m.main_loop()
