# $Id: playfield_capacitors.py 56 2005-09-03 20:46:55Z  $

### Imports ###
import pygame
import time
from playfield_item import *

### Class PlayfieldCapacitor ###
class PlayfieldCapacitor(PlayfieldItem):
	def __init__(self):
		PlayfieldItem.__init__(self)
		self.creationTime	= time.time()
		self.time			= 0
		self.power			= self.CAPACITOR_POWER
		self.current 		= 0
		
	def doFrame(self, timePassed):
		self.current += (1 - self.current) * (1 - pow(self.exponent, -timePassed))
		
	def getItemType(self):
		return 'capacitor'
	
	def age(self):
		"""
		age() -> float
		
		Returns the age of the PlayfieldCapacitor object, in seconds.
		"""
	
		return time.time() - self.creationTime
		
	def update(self, timePassed):
		if self.age() > self.LIFE_SPAN:
			self.kill()

	def setExponent(self, exponent):
		self.exponent = exponent
			
	def getCurrent(self):
		return self.current
   
	def getCurrentPower(self):
		return self.power * self.getCurrent()

### Class PlayfieldCapacitorSmall ###
class PlayfieldCapacitorSmall(PlayfieldCapacitor):
	ITEM_IMAGE_FILE = "../media/images/pf-capacitor-small.png"
	CAPACITOR_POWER	= 100
	LIFE_SPAN		= 1.5 # seconds

### Class PlayfieldCapacitorBig ###
class PlayfieldCapacitorBig(PlayfieldCapacitor):
	ITEM_IMAGE_FILE = "../media/images/pf-capacitor-big.png"
	CAPACITOR_POWER	= 500
	LIFE_SPAN		= 1.0 # seconds
