# $Id: playfield_item.py 56 2005-09-03 20:46:55Z  $

### Imports ###
import pygame
from pygame.sprite import Sprite

### Constants ###
ITEM_DEFAULT_SIZE = (16, 16)

### Class PlayfieldItem ###
class PlayfieldItem(Sprite):
	ITEM_IMAGE_FILE = None

	def __init__(self):
		Sprite.__init__(self)
		if self.ITEM_IMAGE_FILE:
			self.image = pygame.image.load(self.ITEM_IMAGE_FILE)
		else:
			self.image = pygame.surface.Surface(ITEM_DEFAULT_SIZE)
		self.rect = self.image.get_rect()
	
	def doFrame(self, timePassed):
		pass
	
	def blitOn(self, surface):
		surface.blit(self.image,
					 self.rect)
	
	def getItemType(self):
		return 'item'
	
	def savePosition(self):
		"""
		savePosition() -> tuple
		"""
		
		return self.rect.topleft
	
	def restorePosition(self, storedPosition):
		"""
		restorePosition(savedPosition) -> None
		"""
		
		self.rect.topleft = storedPosition
	
	def getSurface(self):
		return self.image

	def move(self, x, y):
		self.rect.topleft = (x, y)
	
	def update(self, timePassed):
		pass

